



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>redis 队列缓存 + mysql 批量入库 + php 离线整合</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">redis 队列缓存 + mysql 批量入库 + php 离线整合</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:20:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>问题分析</h2>
<p>思考：应用网站架构的衍化过程中，应用最新的框架和工具技术固然是最优选择；但是，如果能在<code>现有的框架的基础上提出简单可依赖的解决方案</code>，未尝不是一种提升自我的尝试。</p>
<p>解决：</p>
<ul><li><p>问题一：要求日志最好入库；但是，直接入库mysql确实扛不住，批量入库没有问题，done。【批量入库和直接入库性能差异<a href="http://tech.uc.cn/?p=634" rel="external nofollow noreferrer">参考文章</a>】</p></li>
<li><p>问题二：批量入库就需要有高并发的消息队列，决定采用redis list 仿真实现，而且方便回滚。</p></li>
<li><p>问题三：日志量毕竟大，保存最近30条足矣，决定用php写个离线统计和清理脚本。</p></li></ul>
<h2>一：设计数据库表和存储</h2>
<ul><li><p>考虑到log系统对数据库的性能更多一些，稳定性和安全性没有那么高，<code>存储引擎自然是只支持select insert 没有索引的archive</code>。如果确实有update需求，也可以采用myISAM。</p></li>
<li><p>考虑到log是实时记录的所有数据，数量可能巨大，<code>主键采用bigint，自增即可</code>。</p></li>
<li><p>考虑到log系统<code>以写为主，统计采用离线计算，字段均不要出现索引</code>，因为一方面可能会影响插入数据效率，另外读时候会造成死锁，影响写数据。</p></li></ul>
<h2>二：redis存储数据形成消息队列</h2>
<p>由于高并发，尽可能简单，直接，上代码。</p>
<p>&lt;?php<br />/***************************************************************************<br />*<br />* 获取到的调用日志，存入redis的队列中.<br />* $Id$<br />*<br />**************************************************************************/</p>
<p>/**<br />* @file saveLog.php<br />* @date 2015/11/06 20:47:13<br />* @author:cuihuan<br />* @version $Revision$<br />* @brief<br />*<br />**/</p>
<p>// 获取info<br />$interface_info = $_GET['info'];</p>
<p>// 存入redis队列<br />$redis = new Redis();<br />$redis-&gt;connect('xx', 6379);<br />$redis-&gt;auth("password");</p>
<p>// 加上时间戳存入队列<br />$now_time = date("Y-m-d H:i:s");<br />$redis-&gt;rPush("call_log", $interface_info . "%" . $now_time);<br />$redis-&gt;close();</p>
<p>/* vim: set ts=4 sw=4 sts=4 tw=100 */<br />?&gt;</p>
<h2>三：数据定时批量入库。</h2>
<p>定时读取redis消息队列里面的数据，批量入库。</p>
<p>&lt;?php<br />/**<br /> * 获取redis消息队列中的脚本，拼接sql，批量入库。<br /> * @update 2015-11-07 添加失败消息队列回滚机制 <br /> *<br /> * @Author:cuihuan<br /> * 2015-11-06<br /> * */</p>
<p>// init redis<br />$redis_xx = new Redis();<br />$redis_xx-&gt;connect('ip', port);<br />$redis_xx-&gt;auth("password");</p>
<p>// 获取现有消息队列的长度<br />$count = 0;<br />$max = $redis_xx-&gt;lLen("call_log");</p>
<p>// 获取消息队列的内容，拼接sql<br />$insert_sql = "insert into fb_call_log (`interface_name`, `createtime`) values ";</p>
<p>// 回滚数组<br />$roll_back_arr = array();</p>
<p>while ($count &lt; $max) {<br />    $log_info = $redis_cq01-&gt;lPop("call_log");<br />    $roll_back_arr = $log_info;<br />    if ($log_info == 'nil' || !isset($log_info)) {<br />        $insert_sql .= ";";<br />        break;<br />    }</p>
<p>// 切割出时间和info<br />    $log_info_arr = explode("%",$log_info);<br />    $insert_sql .= " ('".$log_info_arr[0]."','".$log_info_arr[1]."'),";<br />    $count++;<br />}</p>
<p>// 判定存在数据，批量入库<br />if ($count != 0) {<br />    $link_2004 = mysql_connect('ip:port', 'user', 'password');<br />    if (!$link_2004) {<br />        die("Could not connect:" . mysql_error());<br />    }</p>
<p>$crowd_db = mysql_select_db('fb_log', $link_2004);<br />    $insert_sql = rtrim($insert_sql,",").";";<br />    $res = mysql_query($insert_sql);</p>
<p>// 输出入库log和入库结果;<br />    echo date("Y-m-d H:i:s")."insert ".$count." log info result:";<br />    echo json_encode($res);<br />    echo "&lt;/br&gt;\n";</p>
<p>// 数据库插入失败回滚<br />    if(!$res){<br />       foreach($roll_back_arr as $k){<br />           $redis_xx-&gt;rPush("call_log", $k);<br />       }<br />    }</p>
<p>// 释放连接<br />    mysql_free_result($res);<br />    mysql_close($link_2004);<br />}</p>
<p>// 释放redis<br />$redis_cq01-&gt;close();<br />?&gt;</p>
<h2>四：离线天级统计和清理数据脚本</h2>
<p>?php<br />/**<br />* static log ：每天离线统计代码日志和删除五天前的日志<br />*<br />* @Author:cuihuan<br />* 2015-11-06<br />* */</p>
<p>// 离线统计<br />$link_2004 = mysql_connect('ip:port', 'user', 'pwd');<br />if (!$link_2004) {<br />    die("Could not connect:" . mysql_error());<br />}</p>
<p>$crowd_db = mysql_select_db('fb_log', $link_2004);</p>
<p>// 统计昨天的数据<br />$day_time = date("Y-m-d", time() - 60 * 60 * 24 * 1);<br />$static_sql = "get sql";</p>
<p>$res = mysql_query($static_sql, $link_2004);</p>
<p>// 获取结果入库略</p>
<p>// 清理15天之前的数据<br />$before_15_day = date("Y-m-d", time() - 60 * 60 * 24 * 15);<br />$delete_sql = "delete from xxx where createtime &lt; '" . $before_15_day . "'";<br />try {<br />    $res = mysql_query($delete_sql);<br />}catch(Exception $e){<br />    echo json_encode($e)."\n";<br />    echo "delete result:".json_encode($res)."\n";<br />}</p>
<p>mysql_close($link_2004);<br />?&gt;</p>
<h2>五：代码部署</h2>
<p>主要是部署，批量入库脚本的调用和天级统计脚本，crontab例行运行。</p>
<p># 批量入库脚本<br />*/2 * * * * /home/cuihuan/xxx/lamp/php5/bin/php /home/cuihuan/xxx/batchLog.php &gt;&gt;/home/cuihuan/xxx/batchlog.log</p>
<p># 天级统计脚本<br />0 5 * * * /home/cuihuan/xxx/php5/bin/php /home/cuihuan/xxx/staticLog.php &gt;&gt;/home/cuihuan/xxx/staticLog.log</p>
<p>总结：相对于其他复杂的方式处理高并发，这个解决方案简单有效：通过redis缓存抗压，mysql批量入库解决数据库瓶颈，离线计算解决统计数据，通过定期清理保证库的大小。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlj2509.html">学习微信小程序之css10外边距</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyxzyd8.html">JavaWeb学习笔记&mdash;&mdash;JSP标准标签库JSTL</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnp0kx8.html">【读书笔记】iOS网络-运行循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvgj4jq.html">ASP&period;NET一些公共方法commTools</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k157e59.html">9&period;配置postfix空客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydzg4mq.html">C&plus;&plus; 虚函数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy11vr2q.html">HDU4960Another OCD Patient（间隙dp&comma;后座DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10n52q.html">app&period;config 配置多项 配置集合 自定义配置&lpar;3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdplo4vq.html">&period;26-浅析webpack源码之事件流make&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge635l8.html">Ubuntu如何配置SSH免密登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmlkeq.html">ssm简单搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdn3gz9.html">无法生成core dump文件的几个原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11p6lq.html">解决AssetBundle包加载预制体时，Shader显示异常的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyvd5x9.html">centos7&sol;rhel7下配置PXE&plus;Kickstart自动安装linux系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wdkvwq.html">【三】Java VM 发展史</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yy0pq.html">&lbrack;转&rsqb; Ubuntu16&period;04完美安装Sublime text3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw32wx9.html">JS算法之二分查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy7vzgq.html">python中while循环运算符及格式化输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv5pwgq.html">Java数据结构和算法（一）散列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v7rd2q.html">&period;Net生成导出Excel</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qljoe7x9.html">第三次冲刺spring会议（第一次会议）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpm0g79.html">NOIP2005-普及组复赛-第二题-校门外的树</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjdm338.html">java代码块 静态、非静态</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljomy69.html">a标签包含块级元素问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojdj1pq.html">锅巴H264播放器地址和说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge3e508.html">在block函数中规避错误信息 &amp;quot&semi;capturing self strongly in this block is likely to lead to a retain cycle&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k5ke29.html">如何在Eclipse和MyEclipse中安装SVN</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jxkkw8.html">Webdriver控制翻页控件&comma;并实现向前向后翻页功能，附上代码，仅供参考，其他类似日期控件的功能可以自己封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpmo779.html">NOIP2014提高组第二题联合权值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkl27e8.html">典型的DIV＋CSS布局&mdash;&mdash;左中右版式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
